## buffybox 3.2.0+dfsg

=== lvgl/docs/requirements.txt ===
Sphinx
breathe
imagesize
importlib-metadata
sphinx-rtd-theme
sphinx-sitemap
sphinxcontrib-applehelp
sphinxcontrib-devhelp
sphinxcontrib-htmlhelp
sphinxcontrib-jsmath
sphinxcontrib-qthelp
sphinxcontrib-serializinghtml
sphinxcontrib-mermaid
sphinx-design
sphinx-rtd-dark-mode
typing-extensions

=== lvgl/tests/CMakeLists.txt ===
if(ESP_PLATFORM)

###################################
# Tests do not build for ESP-IDF. #
###################################

else()

cmake_minimum_required(VERSION 3.16)

if(WIN32)
    set(VCPKG_TARGET_TRIPLET "x64-windows")
    include($ENV{VCPKG_INSTALLATION_ROOT}/scripts/buildsystems/vcpkg.cmake)
endif()

project(lvgl_tests LANGUAGES C CXX)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_C_STANDARD 99)

set(FLAG_CHECK_WHITELIST --coverage -fsanitize=address -Werror)

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
function(filter_compiler_options lang options_out)
    set(options ${ARGN})
    foreach(option ${options})
        if (option IN_LIST FLAG_CHECK_WHITELIST)
            list(APPEND ${options_out} ${option})
            continue()
        endif ()

        string(TOUPPER FLAG_SUPPORTED_FOR_${lang}_${option} option_var_name)
        string(REPLACE "-" "_" option_var_name ${option_var_name})
        string(REPLACE "+" "_" option_var_name ${option_var_name})

        if (${lang} STREQUAL C)
            check_c_compiler_flag(${option} ${option_var_name})
        elseif (${lang} STREQUAL CXX)
            check_cxx_compiler_flag(${option} ${option_var_name})
        else()
            message(FATAL_ERROR "Unknown language ${lang}")
        endif ()
        if(${option_var_name})
            list(APPEND ${options_out} ${option})
        endif()
    endforeach()
    set(${options_out} ${${options_out}} PARENT_SCOPE)
endfunction()

find_program(VALGRIND_EXECUTABLE valgrind)
if (VALGRIND_EXECUTABLE)
    set(MEMORYCHECK_COMMAND ${VALGRIND_EXECUTABLE})
    set(MEMORYCHECK_COMMAND_OPTIONS --error-exitcode=1)
endif()

include(CTest)

set(LVGL_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR})


set(LVGL_TEST_OPTIONS_VG_LITE
    -DLV_TEST_OPTION=6
)

set(LVGL_TEST_OPTIONS_MINIMAL_MONOCHROME
    -DLV_TEST_OPTION=1
)

set(LVGL_TEST_OPTIONS_NORMAL_8BIT
    -DLV_TEST_OPTION=2
)

set(LVGL_TEST_OPTIONS_16BIT
    -DLV_TEST_OPTION=3
)

set(LVGL_TEST_OPTIONS_FULL_24BIT
    -DLV_TEST_OPTION=4
)

set(LVGL_TEST_OPTIONS_FULL_32BIT
    -DLV_TEST_OPTION=5
)

set(LVGL_TEST_OPTIONS_TEST_SYSHEAP
    -DLV_TEST_OPTION=5
    -DLVGL_CI_USING_SYS_HEAP
    -Wno-unused-but-set-variable # unused variables are common in the dual-heap arrangement
)

set(LVGL_TEST_OPTIONS_TEST_DEFHEAP
    -DLV_TEST_OPTION=5
    -DLV_USE_OBJ_PROPERTY=1      # add obj property test and disable pedantic
    -DLVGL_CI_USING_DEF_HEAP
    -fsanitize=address
    -fsanitize=leak
    -fsanitize=undefined
    --coverage
)

if (OPTIONS_VG_LITE)
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_VG_LITE})
elseif (OPTIONS_NORMAL_8BIT)
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_NORMAL_8BIT})
elseif (OPTIONS_16BIT)
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_16BIT})
elseif (OPTIONS_24BIT)
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_24BIT})
elseif (OPTIONS_FULL_32BIT)
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_FULL_32BIT})
elseif (OPTIONS_TEST_SYSHEAP)
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP} -fsanitize=address -fsanitize=leak -fsanitize=undefined --coverage)
    filter_compiler_options (C TEST_LIBS --coverage -fsanitize=address -fsanitize=leak -fsanitize=undefined)
    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
    set (ENABLE_TESTS ON)
elseif (OPTIONS_TEST_DEFHEAP)
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_DEFHEAP})
    filter_compiler_options (C TEST_LIBS --coverage -fsanitize=address -fsanitize=leak -fsanitize=undefined)
    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
    set (ENABLE_TESTS ON)
elseif (OPTIONS_TEST_MEMORYCHECK)
    # sanitizer is disabled because valgrind uses LD_PRELOAD and the
    # sanitizer lib needs to load first
    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP})
    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
    set (ENABLE_TESTS ON)
else()
    message(FATAL_ERROR "Must provide a known options value (check main.py?).")
endif()

if ($ENV{NON_AMD64_BUILD})
    set(BUILD_TARGET_DEF -DNON_AMD64_BUILD)
    message("Non AMD64 target is specified")

    # Ensure 32-bit build
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m32")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m32")
endif()

if ($ENV{NON_AMD64_BUILD})
    set(CMAKE_LIBRARY_PATH "/usr/lib/i386-linux-gnu" CACHE PATH "search 32bit lib path firstly")
endif()

# Options lvgl and examples are compiled with.
set(COMPILE_OPTIONS
    -DLV_CONF_PATH=${LVGL_TEST_DIR}/src/lv_test_conf.h
    -DLV_BUILD_TEST
    ${BUILD_OPTIONS}
    ${BUILD_TARGET_DEF}
)

if(NOT (CMAKE_C_COMPILER_ID STREQUAL "MSVC"))
    list(APPEND COMPILE_OPTIONS
        -pedantic-errors
        -Wall
        -Wformat-security
        -Wclobbered
        -Wdeprecated
        -Wdouble-promotion
        -Wempty-body
        -Werror
        -Wextra
        -Wformat-security
        -Wmaybe-uninitialized
        -Wmissing-prototypes
        -Wpointer-arith
        -Wmultichar
        -Wpedantic
        -Wreturn-type
        -Wshadow
        -Wshift-negative-value
        -Wsizeof-pointer-memaccess
        #-Wstack-usage=6000
        -Wtype-limits
        -Wundef
        -Wuninitialized
        -Wunreachable-code
        -Werror=float-conversion
        -Werror=strict-aliasing
        -Wno-double-promotion
        -Wno-unused-but-set-parameter
        -Wno-unreachable-code
    )
else()
    list(APPEND COMPILE_OPTIONS
        /W3         # enable all "production quality" warnings
        /we4013     # treat function undefined as error
    )
endif()

list(APPEND COMPILE_OPTIONS
    ${BUILD_OPTIONS}
    ${BUILD_TARGET_DEF}
)

# LV_USE_OBJ_PROPERTY is enabled in option OPTIONS_TEST_DEFHEAP
# It relies on C11 anonymous struct/union support, thus disable warnings.
if(OPTIONS_TEST_DEFHEAP)
    list(REMOVE_ITEM COMPILE_OPTIONS -pedantic-errors -Wpedantic)
endif()

filter_compiler_options(C LVGL_C_COMPILE_OPTIONS ${COMPILE_OPTIONS})

if(NOT (CMAKE_C_COMPILER_ID STREQUAL "MSVC"))
    # Options test cases are compiled with.
    filter_compiler_options(C LVGL_TESTFILE_COMPILE_OPTIONS ${LVGL_C_COMPILE_OPTIONS} -Wno-missing-prototypes)

    filter_compiler_options(CXX LVGL_CXX_COMPILE_OPTIONS
        ${COMPILE_OPTIONS}
        -Wno-shadow
        -Wno-unused-parameter
        -Wno-c++11-extensions
        -Wno-missing-prototypes
        -Wno-deprecated-copy-with-user-provided-dtor
        -Wno-float-conversion
        -Wno-pedantic
    )
else()
    # Options test cases are compiled with.
    filter_compiler_options(C LVGL_TESTFILE_COMPILE_OPTIONS ${LVGL_C_COMPILE_OPTIONS})

    filter_compiler_options(CXX LVGL_CXX_COMPILE_OPTIONS
        ${COMPILE_OPTIONS}
    )
endif()

get_filename_component(LVGL_DIR ${LVGL_TEST_DIR} DIRECTORY)

# Include lvgl project file.
include(${LVGL_DIR}/CMakeLists.txt)
target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:C>: ${LVGL_C_COMPILE_OPTIONS}>)
if(NOT (CMAKE_C_COMPILER_ID STREQUAL "MSVC"))
    target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:ASM>: ${LVGL_C_COMPILE_OPTIONS}>)
endif()
target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:CXX>: ${LVGL_CXX_COMPILE_OPTIONS}>)
if (TARGET lvgl_examples)
  target_compile_options(lvgl_examples PUBLIC ${LVGL_C_COMPILE_OPTIONS})
endif()


set(TEST_INCLUDE_DIRS
    $<BUILD_INTERFACE:${LVGL_TEST_DIR}/src>
    $<BUILD_INTERFACE:${LVGL_TEST_DIR}/unity>
    $<BUILD_INTERFACE:${LVGL_TEST_DIR}>
)

file(GLOB_RECURSE TEST_IMAGES_SRC ${LVGL_TEST_DIR}/test_images/*.c)

add_library(test_common
    STATIC
        src/lv_test_indev.c
        src/lv_test_init.c
        src/lv_test_helpers.c
        src/test_assets/test_animimg001.c
        src/test_assets/test_animimg002.c
        src/test_assets/test_animimg003.c
        src/test_assets/test_img_cogwheel_i4.c
        src/test_assets/test_img_cogwheel_a8.c
        src/test_assets/test_img_cogwheel_rgb565.c
        src/test_assets/test_img_cogwheel_rgb565a8.c
        src/test_assets/test_img_cogwheel_xrgb8888.c
        src/test_assets/test_img_cogwheel_argb8888.c
        src/test_assets/test_font_1.c
        src/test_assets/test_font_2.c
        src/test_assets/test_font_3.c
        src/test_assets/test_font_montserrat_ascii_1bpp.c
        src/test_assets/test_font_montserrat_ascii_2bpp.c
        src/test_assets/test_font_montserrat_ascii_4bpp.c
        src/test_assets/test_font_montserrat_ascii_4bpp_compressed.c
        src/test_assets/test_font_1_bin.c
        src/test_assets/test_font_2_bin.c
        src/test_assets/test_font_3_bin.c
        src/test_assets/test_img_caret_down.c
        src/test_assets/test_arc_bg.c
        src/test_assets/test_img_lvgl_logo_png.c
        src/test_assets/test_img_lvgl_logo_jpg.c
        src/test_assets/test_img_emoji_F617.c
        src/test_assets/test_ubuntu_font.c
        src/test_assets/test_kern_one_otf.c
        src/test_assets/test_imagebutton_left.c
        src/test_assets/test_imagebutton_mid.c
        src/test_assets/test_imagebutton_right.c
        src/test_assets/test_music_button_play.c
        src/test_assets/test_lottie_approve.c
        unity/unity_support.c
        unity/unity.c
        ${TEST_IMAGES_SRC}
)
target_include_directories(test_common PUBLIC ${TEST_INCLUDE_DIRS})
target_compile_options(test_common PUBLIC ${LVGL_TESTFILE_COMPILE_OPTIONS})

# Generate one test executable for each source file pair.
# The sources in ${CMAKE_CURRENT_BINARY_DIR} is auto-generated, the
# sources in src/test_cases is the actual test case.
find_package(Ruby REQUIRED)
set(generate_test_runner_rb
    ${CMAKE_CURRENT_SOURCE_DIR}/unity/generate_test_runner.rb)
set(generate_test_runner_config ${CMAKE_CURRENT_SOURCE_DIR}/config.yml)

if(NOT WIN32)
    # libjpeg is required for the jpeg test case
    find_package(JPEG REQUIRED)
    include_directories(${JPEG_INCLUDE_DIR})
endif()

# libpng is required for the png test case
find_package(PNG REQUIRED)
include_directories(${PNG_INCLUDE_DIR})

# libfreetype is required for the font test case
find_package(Freetype REQUIRED)
include_directories(${FREETYPE_INCLUDE_DIRS})

# libinput is required for the libinput device driver test case
find_package(Libinput OPTIONAL_COMPONENTS)
if ($ENV{NON_AMD64_BUILD})
    include_directories(${LIBINPUT_INCLUDE_DIRS})
endif()

if (NOT LIBINPUT_FOUND)
    message("libinput not found, defaulting to 0")
    add_definitions(-DLV_USE_LIBINPUT=0)
endif()

find_package(PkgConfig)
pkg_check_modules(xkbcommon pkg_check_modules xkbcommon)

if (NOT xkbcommon_FOUND)
    message("xkbcommon not found, defaulting to 0")
    add_definitions(-DLV_LIBINPUT_XKB=0)
endif()

# libdrm is required for the DRM display driver test case
include(${CMAKE_CURRENT_LIST_DIR}/FindLibDRM.cmake)
if(Libdrm_FOUND)
    include_directories(${Libdrm_INCLUDE_DIRS})
else()
    message("libdrm not found, defaulting to 0")
    add_definitions(-DLV_USE_LINUX_DRM=0)
endif()

# If we are running on mac, set LV_USE_LINUX_FBDEV to 0
if(APPLE)
    add_definitions(-DLV_USE_LINUX_FBDEV=0)
endif()

if(WIN32)
    add_definitions(-DLV_USE_LINUX_FBDEV=0)
    add_definitions(-DLV_USE_WINDOWS=1)
endif()

# disable test targets for build only tests
if (ENABLE_TESTS)
    file(GLOB_RECURSE TEST_CASE_FILES src/test_cases/*.c)
    file(GLOB_RECURSE TEST_LIBS_FILES src/test_libs/*.c)
else()
    set(TEST_CASE_FILES)
    set(TEST_LIBS_FILES)
endif()

# build a test libs target
if (TEST_LIBS_FILES)
    add_library(test_libs STATIC ${TEST_LIBS_FILES})
    target_include_directories(test_libs PUBLIC ${TEST_INCLUDE_DIRS} "src/test_libs")
    target_compile_options(test_libs PUBLIC ${LVGL_TESTFILE_COMPILE_OPTIONS})
    list(APPEND TEST_LIBS test_libs)
endif()

foreach( test_case_fname ${TEST_CASE_FILES} )
    # If test file is foo/bar/baz.c then test_name is "baz".
    get_filename_component(test_name ${test_case_fname} NAME_WLE)
    if (${test_name} STREQUAL "_test_template")
        continue()
    endif()

    # gather all test cases
    list(APPEND TEST_CASES ${test_name})

    # Create path to auto-generated source file.

=== debian/changelog ===
buffybox (3.2.0+dfsg-1) unstable; urgency=medium

  * Initial Release (Closes: #1083296)

 -- Jarrah Gosbell <debian@undef.tools>  Fri, 04 Oct 2024 09:43:29 +0000

=== debian/control ===
Source: buffybox
Section: utils
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders: Jarrah Gosbell <debian@undef.tools>
Build-Depends: debhelper-compat (= 13),
    libdrm-dev,
    libinih-dev,
    libinput-dev,
    libudev-dev,
    libxkbcommon-dev,
    meson,
    po-debconf,
    scdoc,
Standards-Version: 4.7.0
Homepage: https://gitlab.com/postmarketOS/buffybox
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/buffybox
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/buffybox.git
Rules-Requires-Root: no

Package: unl0kr
Architecture: any
Depends: ${misc:Depends},
    ${shlibs:Depends},
    cryptsetup-initramfs,
Breaks: osk-sdl (<<0.67.1-4)
Replaces: osk-sdl (<<0.67.1-4)
Provides: osk-sdl
Description: Lightweight framebuffer On-Screen-Keyboard based on LVGL
 This keyboard is designed to unlock encrypted root partitions on boot
 on mobile devices. It is automatically launched on boot, allowing the
 user to enter their disk encryption password.

Package: buffyboard
Architecture: any
Depends: ${misc:Depends},
    ${shlibs:Depends},
Description: Touch-enabled framebuffer keyboard (not only) for vampire slayers
 Buffyboard is a touch-enabled on-screen keyboard running on the Linux
 framebuffer. It's primarily intended for vampire hunting but you can also
 use it as a general purpose keyboard.
 .
 Buffyboard uses LVGL for input processing and rendering. Key events are
 forwarded directly to the kernel via a uinput device. Since the latter
 emulates a hardware keyboard, the terminal keymap must match with buffyboard's
 layout or else on-screen keys might not produce the correct result.

=== debian/watch ===
version=4
opts=dversionmangle=auto,searchmode=plain,repacksuffix=+dfsg,repack,compression=xz \
https://gitlab.com/api/v4/projects/52322952/releases \
https://gitlab.com/-/project/52322952/uploads/[0-9a-z]*/@PACKAGE@-@ANY_VERSION@.tar.gz

## buffybox 3.4.2+dfsg

=== meson_options.txt ===
option('with-drm', type: 'feature', value: 'auto', description: 'Enable DRM backend')
option('man', type: 'boolean', value: true, description: 'Install manual pages')
option('systemd-buffyboard-service', type: 'feature', value: 'auto', description: 'Install systemd service file for buffyboard')
option('systemd-password-agent', type: 'feature', value: 'auto', description: 'Build a systemd password agent for touchscreens')

=== lvgl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12.4)

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

if(NOT ESP_PLATFORM)
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_LIST_DIR)
    project(
      lvgl
      LANGUAGES C
      HOMEPAGE_URL https://github.com/lvgl/lvgl)
  endif()
  if(NOT (CMAKE_C_COMPILER_ID STREQUAL "MSVC"))
    enable_language(CXX ASM)
  else()
    enable_language(CXX)
  endif()
endif()

set(LVGL_ROOT_DIR ${CMAKE_CURRENT_LIST_DIR})

if(ESP_PLATFORM)
  include(${CMAKE_CURRENT_LIST_DIR}/env_support/cmake/esp.cmake)
elseif(MICROPY_DIR)
  include(${CMAKE_CURRENT_LIST_DIR}/env_support/cmake/micropython.cmake)
else()
  include(${CMAKE_CURRENT_LIST_DIR}/env_support/cmake/os_desktop.cmake)
endif()

#[[
    unfortunately CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS does not work for global data. 
    for global data we still need decl specs.
    Check out the docs to learn more about the limitations of CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS
    https://cmake.org/cmake/help/latest/prop_tgt/WINDOWS_EXPORT_ALL_SYMBOLS.html#prop_tgt:WINDOWS_EXPORT_ALL_SYMBOLS

    For all compiled sources within the library (i.e. basically all lvgl files) we need to use dllexport.
    For all compiled sources from outside the library (i.e. files which include lvgl headers) we need to use dllimport.
    We can do this by using CMakes INTERFACE and PRIVATE keyword.
  ]]
if (MSVC)
  target_compile_definitions(lvgl
    INTERFACE LV_ATTRIBUTE_EXTERN_DATA=__declspec\(dllimport\)
    PRIVATE LV_ATTRIBUTE_EXTERN_DATA=__declspec\(dllexport\)
  )
endif()

=== lvgl/docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = intermediate
BUILDDIR      = build

# SOURCEDIR can be overridden by LVGL_DOC_BUILD_INTERMEDIATE_DIR
LEN           := $(shell printf '%s' '$(LVGL_DOC_BUILD_INTERMEDIATE_DIR)' | wc -c)

ifeq ($(shell test $(LEN) -gt 0; echo $$?),0)
	SOURCEDIR = $(LVGL_DOC_BUILD_INTERMEDIATE_DIR)
else
	SOURCEDIR = intermediate
endif

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
# It can be supplied from an environment variable 'O' or on make command line.
%: Makefile
	$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== lvgl/docs/requirements.txt ===
Sphinx
breathe
imagesize
importlib-metadata
sphinx-sitemap
sphinxcontrib-applehelp
sphinxcontrib-devhelp
sphinxcontrib-htmlhelp
sphinxcontrib-jsmath
sphinxcontrib-qthelp
sphinxcontrib-serializinghtml
sphinxcontrib-mermaid==0.9.2
sphinx-copybutton
sphinx-design
typing-extensions
sphinx-reredirects
dirsync
furo
accessible-pygments

=== lvgl/tests/CMakeLists.txt ===
--- 
+++ 
@@ -57,9 +57,20 @@
 
 set(LVGL_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR})
 
+set(SANITIZE_AND_COVERAGE_OPTIONS
+    -fsanitize=address
+    -fsanitize=leak
+    -fsanitize=undefined
+    --coverage
+)
 
 set(LVGL_TEST_OPTIONS_VG_LITE
     -DLV_TEST_OPTION=6
+    -Wno-dangling-pointer # workaround for thorvg dangling-pointer warning
+)
+
+set(LVGL_TEST_OPTIONS_SDL
+    -DLV_TEST_OPTION=7
 )
 
 set(LVGL_TEST_OPTIONS_MINIMAL_MONOCHROME
@@ -86,20 +97,19 @@
     -DLV_TEST_OPTION=5
     -DLVGL_CI_USING_SYS_HEAP
     -Wno-unused-but-set-variable # unused variables are common in the dual-heap arrangement
+    ${SANITIZE_AND_COVERAGE_OPTIONS}
 )
 
 set(LVGL_TEST_OPTIONS_TEST_DEFHEAP
     -DLV_TEST_OPTION=5
     -DLV_USE_OBJ_PROPERTY=1      # add obj property test and disable pedantic
+    -DLV_USE_OBJ_PROPERTY_NAME=1
     -DLVGL_CI_USING_DEF_HEAP
-    -fsanitize=address
-    -fsanitize=leak
-    -fsanitize=undefined
-    --coverage
-)
-
-if (OPTIONS_VG_LITE)
-    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_VG_LITE})
+    ${SANITIZE_AND_COVERAGE_OPTIONS}
+)
+
+if (OPTIONS_SDL)
+    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_SDL})
 elseif (OPTIONS_NORMAL_8BIT)
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_NORMAL_8BIT})
 elseif (OPTIONS_16BIT)
@@ -109,21 +119,36 @@
 elseif (OPTIONS_FULL_32BIT)
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_FULL_32BIT})
 elseif (OPTIONS_TEST_SYSHEAP)
-    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP} -fsanitize=address -fsanitize=leak -fsanitize=undefined --coverage)
-    filter_compiler_options (C TEST_LIBS --coverage -fsanitize=address -fsanitize=leak -fsanitize=undefined)
-    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
+    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP})
+    filter_compiler_options (C TEST_LIBS ${SANITIZE_AND_COVERAGE_OPTIONS})
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
     set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs/")
 elseif (OPTIONS_TEST_DEFHEAP)
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_DEFHEAP})
-    filter_compiler_options (C TEST_LIBS --coverage -fsanitize=address -fsanitize=leak -fsanitize=undefined)
-    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
+    filter_compiler_options (C TEST_LIBS ${SANITIZE_AND_COVERAGE_OPTIONS})
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
     set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs/")
 elseif (OPTIONS_TEST_MEMORYCHECK)
     # sanitizer is disabled because valgrind uses LD_PRELOAD and the
     # sanitizer lib needs to load first
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP})
-    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
     set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs/")
+elseif (OPTIONS_TEST_VG_LITE)
+    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_VG_LITE} -DLVGL_CI_USING_SYS_HEAP ${SANITIZE_AND_COVERAGE_OPTIONS})
+    filter_compiler_options (C TEST_LIBS ${SANITIZE_AND_COVERAGE_OPTIONS})
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
+    set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs_vg_lite/")
+
+    # In 32-bit systems, the output of ThorVG's anti-aliasing algorithm has a slight deviation.
+    if ($ENV{NON_AMD64_BUILD})
+        # Set a tolerance value for the VG-Lite tests.
+        add_definitions(-DREF_IMG_TOLERANCE=9)
+    endif()
 else()
     message(FATAL_ERROR "Must provide a known options value (check main.py?).")
 endif()
@@ -145,8 +170,6 @@
 
 # Options lvgl and examples are compiled with.
 set(COMPILE_OPTIONS
-    -DLV_CONF_PATH=${LVGL_TEST_DIR}/src/lv_test_conf.h
-    -DLV_BUILD_TEST
     ${BUILD_OPTIONS}
     ${BUILD_TARGET_DEF}
 )
@@ -180,8 +203,10 @@
         -Werror=float-conversion
         -Werror=strict-aliasing
         -Wno-double-promotion
-        -Wno-unused-but-set-parameter
         -Wno-unreachable-code
+        -Wno-gnu-zero-variadic-macro-arguments
+        -Wunused-function
+	-Wno-overlength-strings
     )
 else()
     list(APPEND COMPILE_OPTIONS
@@ -229,30 +254,48 @@
 get_filename_component(LVGL_DIR ${LVGL_TEST_DIR} DIRECTORY)
 
 # Include lvgl project file.
+# Set LV_BUILD_CONF_PATH so os_desktop.cmake knows about it before compiling lvgl
+# Used to preprocess lv_conf_internal.h with the test config
+set(LV_BUILD_CONF_PATH "${LVGL_TEST_DIR}/src/lv_test_conf.h" CACHE STRING "set test configuration")
+
 include(${LVGL_DIR}/CMakeLists.txt)
 target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:C>: ${LVGL_C_COMPILE_OPTIONS}>)
+target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+target_compile_definitions(lvgl PUBLIC LV_BUILD_TEST)
 if(NOT (CMAKE_C_COMPILER_ID STREQUAL "MSVC"))
-    target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:ASM>: ${LVGL_C_COMPILE_OPTIONS}>)
-endif()
-target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:CXX>: ${LVGL_CXX_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:ASM>:${LVGL_C_COMPILE_OPTIONS}>)
+endif()
+
+if (TARGET lvgl_thorvg)
+    target_compile_options(lvgl_thorvg PUBLIC $<$<COMPILE_LANGUAGE:C>:${LVGL_C_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl_thorvg PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+endif()
+
 if (TARGET lvgl_examples)
-  target_compile_options(lvgl_examples PUBLIC ${LVGL_C_COMPILE_OPTIONS})
-endif()
-
+    target_compile_options(lvgl_examples PUBLIC $<$<COMPILE_LANGUAGE:C>:${LVGL_C_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl_examples PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+endif()
+
+if (TARGET lvgl_demos)
+    target_compile_options(lvgl_demos PUBLIC $<$<COMPILE_LANGUAGE:C>:${LVGL_C_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl_demos PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+endif()
+
+
+# LVGL_CONF_DIR and LVGL_CONF_PATH are normalized and set by os_desktop.cmake
 
 set(TEST_INCLUDE_DIRS
     $<BUILD_INTERFACE:${LVGL_TEST_DIR}/src>
     $<BUILD_INTERFACE:${LVGL_TEST_DIR}/unity>
     $<BUILD_INTERFACE:${LVGL_TEST_DIR}>
+    $<BUILD_INTERFACE:${LVGL_CONF_DIR}>
 )
 
 file(GLOB_RECURSE TEST_IMAGES_SRC ${LVGL_TEST_DIR}/test_images/*.c)
 
 add_library(test_common
     STATIC
-        src/lv_test_indev.c
         src/lv_test_init.c
-        src/lv_test_helpers.c
         src/test_assets/test_animimg001.c
         src/test_assets/test_animimg002.c
         src/test_assets/test_animimg003.c
@@ -262,13 +305,15 @@
         src/test_assets/test_img_cogwheel_rgb565a8.c
         src/test_assets/test_img_cogwheel_xrgb8888.c
         src/test_assets/test_img_cogwheel_argb8888.c
+        src/test_assets/test_img_svg.c
         src/test_assets/test_font_1.c
         src/test_assets/test_font_2.c
         src/test_assets/test_font_3.c
         src/test_assets/test_font_montserrat_ascii_1bpp.c
         src/test_assets/test_font_montserrat_ascii_2bpp.c
         src/test_assets/test_font_montserrat_ascii_4bpp.c
-        src/test_assets/test_font_montserrat_ascii_4bpp_compressed.c
+        src/test_assets/test_font_montserrat_ascii_8bpp.c
+        src/test_assets/test_font_montserrat_ascii_3bpp_compressed.c
         src/test_assets/test_font_1_bin.c
         src/test_assets/test_font_2_bin.c
         src/test_assets/test_font_3_bin.c
@@ -284,12 +329,12 @@
         src/test_assets/test_imagebutton_right.c
         src/test_assets/test_music_button_play.c
         src/test_assets/test_lottie_approve.c
-        unity/unity_support.c
         unity/unity.c
         ${TEST_IMAGES_SRC}
 )
 target_include_directories(test_common PUBLIC ${TEST_INCLUDE_DIRS})
 target_compile_options(test_common PUBLIC ${LVGL_TESTFILE_COMPILE_OPTIONS})
+target_compile_definitions(test_common PRIVATE LV_BUILD_TEST ${LVGL_COMPILER_DEFINES})
 
 # Generate one test executable for each source file pair.
 # The sources in ${CMAKE_CURRENT_BINARY_DIR} is auto-generated, the
@@ -303,79 +348,9 @@
     # libjpeg is required for the jpeg test case
     find_package(JPEG REQUIRED)
     include_directories(${JPEG_INCLUDE_DIR})
-endif()
-
-# libpng is required for the png test case
-find_package(PNG REQUIRED)
-include_directories(${PNG_INCLUDE_DIR})
-
-# libfreetype is required for the font test case
-find_package(Freetype REQUIRED)
-include_directories(${FREETYPE_INCLUDE_DIRS})
-
-# libinput is required for the libinput device driver test case
-find_package(Libinput OPTIONAL_COMPONENTS)
-if ($ENV{NON_AMD64_BUILD})
-    include_directories(${LIBINPUT_INCLUDE_DIRS})
-endif()
-
-if (NOT LIBINPUT_FOUND)
-    message("libinput not found, defaulting to 0")
-    add_definitions(-DLV_USE_LIBINPUT=0)
-endif()
-
-find_package(PkgConfig)
-pkg_check_modules(xkbcommon pkg_check_modules xkbcommon)
-
-if (NOT xkbcommon_FOUND)
-    message("xkbcommon not found, defaulting to 0")
-    add_definitions(-DLV_LIBINPUT_XKB=0)
-endif()
-
-# libdrm is required for the DRM display driver test case
-include(${CMAKE_CURRENT_LIST_DIR}/FindLibDRM.cmake)
-if(Libdrm_FOUND)
-    include_directories(${Libdrm_INCLUDE_DIRS})
-else()
-    message("libdrm not found, defaulting to 0")
-    add_definitions(-DLV_USE_LINUX_DRM=0)
-endif()
-
-# If we are running on mac, set LV_USE_LINUX_FBDEV to 0
-if(APPLE)
-    add_definitions(-DLV_USE_LINUX_FBDEV=0)
-endif()
-
-if(WIN32)
-    add_definitions(-DLV_USE_LINUX_FBDEV=0)
-    add_definitions(-DLV_USE_WINDOWS=1)
-endif()
-
-# disable test targets for build only tests
-if (ENABLE_TESTS)
-    file(GLOB_RECURSE TEST_CASE_FILES src/test_cases/*.c)
-    file(GLOB_RECURSE TEST_LIBS_FILES src/test_libs/*.c)
-else()
-    set(TEST_CASE_FILES)
-    set(TEST_LIBS_FILES)
-endif()
-
-# build a test libs target
-if (TEST_LIBS_FILES)
-    add_library(test_libs STATIC ${TEST_LIBS_FILES})
-    target_include_directories(test_libs PUBLIC ${TEST_INCLUDE_DIRS} "src/test_libs")
-    target_compile_options(test_libs PUBLIC ${LVGL_TESTFILE_COMPILE_OPTIONS})
-    list(APPEND TEST_LIBS test_libs)
-endif()
-
-foreach( test_case_fname ${TEST_CASE_FILES} )
-    # If test file is foo/bar/baz.c then test_name is "baz".
-    get_filename_component(test_name ${test_case_fname} NAME_WLE)
-    if (${test_name} STREQUAL "_test_template")
-        continue()
-    endif()
-
-    # gather all test cases
-    list(APPEND TEST_CASES ${test_name})
-
-    # Create path to auto-generated source file.
+
+    # Wayland
+    find_package(PkgConfig)
+    pkg_check_modules(wayland_client wayland-client)
+
+    if (wayland_client_FOUND)

=== debian/changelog ===
buffybox (3.4.2+dfsg-1) unstable; urgency=medium

  [ Jarrah Gosbell ]
  * d/copyright: Add upstream contact
  * d/rules: Don't replace dh clean to ensure package can build twice
  * d/control: Bump standards version (no changes required)
  * d/copyright: Fix missed flies/entries from package review
  * d/po: Unfuzzy untranslatable string in translations
  * d/copyright: Last couple of copyright fixes from review
  * d/initramfs: Add kernel modules required for PinePhone Pro
  * d/control: Add missing dependency "po-debconf"
  * New upstream version 3.4.2+dfsg
  * Update watch/copyright for v3.4.2 and new repository (Closes: #1115888)
  * d/copyright: Update for 3.4.2
  * d/patches: Remove patches fixed upstream
  * d/initramfs: Update keyscript for new no newline option
  * d/readme: Include comment about F0rmz not being included
  * d/not-installed: Do not install f0rmz
  * d/watch: Migrate to v5
  * d/source/lintian-overrides: Override examples and watch
  * d/control: Update standards version

  [ Yifei Zhan ]
  * update to the new upstream URL

  [ Andrea Bolognani ]
  * d/initramfs: Ensure target directories exist
  * d/initramfs: Copy xkb-data correctly (Closes: #1124611)
  * d/README.Debian: Fix typo
  * d/README.Debian: Explain how to set up unl0kr after installation
  * d/copyright: Update upstream URLs

  [ Carles Pina i Estany ]
  * Added po-debconf Catalan translation (Closes: #1109188)

  [ Martin Bagge ]
  * d/po: Add Sweedish translation (Closes: #1068857)

  [ Yangfl ]
  * d/po: Add Chinese translations (Closes: #1124967)

 -- Jarrah Gosbell <debian@undef.tools>  Tue, 06 Jan 2026 07:21:05 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: buffybox
 Section: utils
-Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Jarrah Gosbell <debian@undef.tools>
 Build-Depends: debhelper-compat (= 13),
@@ -12,11 +11,10 @@
     meson,
     po-debconf,
     scdoc,
-Standards-Version: 4.7.0
-Homepage: https://gitlab.com/postmarketOS/buffybox
+Standards-Version: 4.7.3
+Homepage: https://gitlab.postmarketos.org/postmarketOS/buffybox
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/buffybox
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/buffybox.git
-Rules-Requires-Root: no
 
 Package: unl0kr
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	debconf-updatepo
	dh_auto_clean

=== debian/watch ===
Version: 5
# We can't just use the template here because we need the tarball with LVGL packed as well.
# Git with submodules may also work.
Source: https://gitlab.postmarketos.org/api/v4/projects/172/releases
Matching-Pattern: https://gitlab.postmarketos.org/-/project/172/uploads/[0-9a-z]*/@PACKAGE@-@ANY_VERSION@.tar.gz
Repack: yes
RepackSuffix: +dfsg
Compression: xz
Search-Mode: plain
Dversion-Mangle: auto
